/// <reference types="angular" />
/// <reference types="angular-route" />
import { userdata, api, entityCtrl, entitiesCtrl } from "./CommonControllers";
import { TokenUser, NoderedUser, Billing, stripe_customer, stripe_list, stripe_base, stripe_plan, stripe_subscription_item, Base, Role, stripe_invoice } from "@openiap/openflow-api";
import { RPAWorkflow, Provider, Form, WorkflowInstance, Workflow, unattendedclient } from "./Entities";
import { WebSocketClientService } from "./WebSocketClientService";
export declare class jsutil {
    static ensureJQuery(): Promise<void>;
    static loadScript(url: string): Promise<void>;
    static getScript(url: string): Promise<void>;
}
export declare class RPAWorkflowCtrl extends entityCtrl<RPAWorkflow> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    arguments: any;
    users: TokenUser[];
    user: TokenUser;
    messages: string;
    queuename: string;
    timeout: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    loadUsers(): Promise<void>;
    submit(): Promise<void>;
}
export declare class RPAWorkflowsCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    dographs(): Promise<void>;
    download(data: any, filename: any, type: any): void;
    Download(model: any): Promise<void>;
}
export declare class WorkflowsCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
}
export declare class chartset {
    options: any;
    baseColors: [
        '#97BBCD',
        '#DCDCDC',
        '#F7464A',
        '#46BFBD',
        '#FDB45C',
        '#949FB1',
        '#4D5360'
    ];
    colors: string[];
    type: string;
    heading: string;
    labels: string[];
    series: string[];
    data: any[];
    ids: any[];
    charttype: string;
    click: any;
}
export declare function emit(k: any, v: any): any;
export declare class ReportsCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    datatimeframe: Date;
    onlinetimeframe: Date;
    timeframedesc: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    settimeframe(days: any, hours: any, desc: any): void;
    processData(): Promise<void>;
    robotsclick(points: any, evt: any): Promise<void>;
    robotclick(points: any, evt: any): Promise<void>;
    workflowclick(points: any, evt: any): Promise<void>;
    InsertNew(): Promise<void>;
    UpdateOne(model: any): Promise<any>;
}
export declare class MainCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    showcompleted: boolean;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
}
export declare class LoginCtrl {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    localenabled: boolean;
    scanning: boolean;
    qrcodescan: boolean;
    providers: any;
    username: string;
    password: string;
    message: string;
    domain: string;
    allow_user_registration: boolean;
    static $inject: string[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, WebSocketClientService: WebSocketClientService, api: api);
    readfile(filename: string): Promise<string>;
    writefile(filename: string, content: string): Promise<void>;
    scanForQRScanner(): void;
    Scan(): void;
    QRScannerHit(err: any, value: any): Promise<void>;
    submit(): Promise<void>;
    Signup(): void;
    setCookie(cname: any, cvalue: any, exdays: any): void;
    getCookie(cname: any): string;
}
export declare class MenuCtrl {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    user: TokenUser;
    signedin: boolean;
    path: string;
    static $inject: string[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, WebSocketClientService: WebSocketClientService, api: api);
    routeChangeStart(event: any, next: any, current: any): void;
    hasrole(role: string): boolean;
    hascordova(): boolean;
    stopimpersonation(): void;
    PathIs(path: string): boolean;
}
export declare class ProvidersCtrl extends entitiesCtrl<Provider> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: any;
    userdata: userdata;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: any, userdata: userdata);
}
export declare class ProviderCtrl extends entityCtrl<Provider> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    submit(): Promise<void>;
}
export declare class UsersCtrl extends entitiesCtrl<TokenUser> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
    Impersonate(model: TokenUser): Promise<any>;
    DeleteOneUser(model: TokenUser): Promise<any>;
}
export declare class UserCtrl extends entityCtrl<TokenUser> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    newid: string;
    memberof: Role[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    processdata(): Promise<void>;
    deleteid(id: any): void;
    addid(): void;
    RemoveMember(model: Role): void;
    submit(): Promise<void>;
}
export declare class RolesCtrl extends entitiesCtrl<Role> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
}
export declare class RoleCtrl extends entityCtrl<Role> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    searchFilteredList: Role[];
    searchSelectedItem: Role;
    searchtext: string;
    e: any;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    submit(): Promise<void>;
    RemoveMember(model: any): void;
    AddMember(model: any): void;
    restrictInput(e: any): boolean;
    setkey(e: any): void;
    handlekeys(): void;
    handlefilter(e: any): Promise<void>;
    fillTextbox(searchtext: any): void;
}
export declare class SocketCtrl {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    static $inject: string[];
    messages: string;
    queuename: string;
    message: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, WebSocketClientService: WebSocketClientService, api: api);
}
export declare class FilesCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    file: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    Download(id: string): Promise<void>;
    b64toBlob(b64Data: string, contentType: string, sliceSize?: number): Blob;
    Upload(): Promise<void>;
    Upload_usingapi(): Promise<void>;
}
export declare class EntitiesCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    collections: any;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    SelectCollection(): void;
    DropCollection(): Promise<void>;
}
export declare class FormsCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
}
export declare class EditFormCtrl extends entityCtrl<Form> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    message: string;
    charts: chartset[];
    formBuilder: any;
    Formiobuilder: any;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    Save(): Promise<void>;
    renderform(): Promise<void>;
}
export declare class FormCtrl extends entityCtrl<WorkflowInstance> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    message: string;
    formRender: any;
    formioRender: any;
    workflow: Workflow;
    form: Form;
    instanceid: string;
    myid: string;
    submitbutton: string;
    queuename: string;
    queue_message_timeout: number;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    hideFormElements(): Promise<void>;
    loadData(): Promise<void>;
    SendOne(queuename: string, message: any): Promise<void>;
    Save(): Promise<void>;
    traversecomponentsPostProcess(components: any[], data: any): void;
    traversecomponentsMakeDefaults(components: any[]): void;
    traversecomponentsAddCustomValidate(components: any[]): void;
    sleep(ms: any): Promise<unknown>;
    beforeSubmit(submission: any, next: any): Promise<void>;
    renderform(): Promise<void>;
}
export declare class jslogCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    DeleteMany(): Promise<void>;
}
export declare class EntityCtrl extends entityCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    searchFilteredList: TokenUser[];
    searchSelectedItem: TokenUser;
    searchtext: string;
    e: any;
    newkey: string;
    showjson: boolean;
    jsonmodel: string;
    message: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    processdata(): void;
    fixtextarea(): void;
    togglejson(): void;
    submit(): Promise<void>;
    removekey(key: any): void;
    addkey(): void;
    removeuser(_id: any): void;
    adduser(): void;
    isBitSet(base64: string, bit: number): boolean;
    setBit(base64: string, bit: number): string;
    unsetBit(base64: string, bit: number): string;
    toogleBit(a: any, bit: number): void;
    _base64ToArrayBuffer(string_base64: any): ArrayBuffer;
    _arrayBufferToBase64(array_buffer: any): string;
    restrictInput(e: any): boolean;
    setkey(e: any): void;
    handlekeys(): void;
    handlefilter(e: any): Promise<void>;
    fillTextbox(searchtext: any): void;
}
export declare class HistoryCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    id: string;
    model: Base;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    ProcessData(): Promise<void>;
    CompareNow(model: any): Promise<void>;
    CompareThen(model: any): Promise<void>;
    RevertTo(model: any): Promise<void>;
}
export declare class NoderedCtrl {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    static $inject: string[];
    messages: string;
    errormessage: string;
    queuename: string;
    noderedurl: string;
    instance: any;
    instances: any[];
    instancestatus: string;
    instancelog: string;
    name: string;
    instancename: string;
    userid: string;
    user: NoderedUser;
    limitsmemory: string;
    loading: boolean;
    labels: any;
    keys: string[];
    labelkeys: string[];
    label: any;
    newkey: string;
    newvalue: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, WebSocketClientService: WebSocketClientService, api: api);
    save(): Promise<void>;
    GetNoderedInstance(): Promise<void>;
    GetNoderedInstanceLog(instancename: string): Promise<void>;
    EnsureNoderedInstance(): Promise<void>;
    DeleteNoderedInstance(): Promise<void>;
    DeleteNoderedPod(instancename: string): Promise<void>;
    RestartNoderedInstance(): Promise<void>;
    StartNoderedInstance(): Promise<void>;
    StopNoderedInstance(): Promise<void>;
    addkey(): void;
    removekey(key: any): void;
    newkeyselected(): void;
}
export declare class hdrobotsCtrl extends entitiesCtrl<unattendedclient> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    Enable(model: any): Promise<any>;
    Disable(model: any): Promise<any>;
}
export declare class ClientsCtrl extends entitiesCtrl<unattendedclient> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    showall: boolean;
    showinactive: boolean;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    ShowWorkflows(model: any): void;
    OpenNodered(model: any): void;
    ManageNodered(model: any): void;
    Impersonate(model: TokenUser): Promise<any>;
}
export declare class AuditlogsCtrl extends entitiesCtrl<Role> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    model: Role;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    ShowAudit(model: any): Promise<any>;
}
export declare class SignupCtrl extends entityCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    searchFilteredList: TokenUser[];
    searchSelectedItem: TokenUser;
    searchtext: string;
    e: any;
    newkey: string;
    showjson: boolean;
    jsonmodel: string;
    message: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    processdata(): void;
}
export declare class PaymentCtrl extends entityCtrl<Billing> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    messages: string;
    cardmessage: string;
    errormessage: string;
    stripe: any;
    stripe_customer: stripe_customer;
    stripe_products: stripe_list<stripe_base>;
    stripe_plans: stripe_list<stripe_plan>;
    hastaxtext: string;
    userid: string;
    taxstatus: string;
    taxaddress: string;
    hascustomer: boolean;
    allowopenflowsignup: boolean;
    allowsupportsignup: boolean;
    hastaxinfo: boolean;
    openflowplan: stripe_plan;
    supportplan: stripe_plan;
    supporthoursplan: stripe_plan;
    supportsubscription: stripe_subscription_item;
    supporthourssubscription: stripe_subscription_item;
    openflowplans: stripe_plan[];
    supportplans: stripe_plan[];
    supporthoursplans: stripe_plan[];
    nextbill: stripe_invoice;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    processdata(): Promise<void>;
    Save(): Promise<void>;
    CancelPlan(planid: string): Promise<void>;
    AddHours(plan: string): Promise<void>;
    CheckOut(planid: string, subplanid: string): Promise<void>;
}
export declare class QueuesCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    DumpRabbitmq(): Promise<void>;
}
export declare class QueueCtrl extends entityCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    newid: string;
    memberof: Role[];
    data: any;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    processdata(): Promise<void>;
    DeleteQueue(model: any): Promise<void>;
}
export declare class SocketsCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    message: string;
    charts: chartset[];
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processdata(): void;
    DumpClients(): Promise<void>;
}
export declare class CredentialsCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
    DeleteOneUser(model: TokenUser): Promise<any>;
}
export declare class CredentialCtrl extends entityCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    searchFilteredList: TokenUser[];
    searchSelectedItem: TokenUser;
    searchtext: string;
    e: any;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    submit(): Promise<void>;
    removeuser(_id: any): void;
    adduser(): void;
    isBitSet(base64: string, bit: number): boolean;
    setBit(base64: string, bit: number): string;
    unsetBit(base64: string, bit: number): string;
    toogleBit(a: any, bit: number): void;
    _base64ToArrayBuffer(string_base64: any): ArrayBuffer;
    _arrayBufferToBase64(array_buffer: any): string;
    restrictInput(e: any): boolean;
    setkey(e: any): void;
    handlekeys(): void;
    handlefilter(e: any): Promise<void>;
    fillTextbox(searchtext: any): void;
}
export declare class OAuthClientsCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    processData(): Promise<void>;
}
export declare class OAuthClientCtrl extends entityCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    searchFilteredList: TokenUser[];
    searchSelectedItem: TokenUser;
    searchtext: string;
    e: any;
    rolemappings: any;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api);
    submit(): Promise<void>;
    deletefromarray(name: string, id: string): boolean;
    addtoarray(name: string, id: string): boolean;
    addrolemapping(name: string, value: string): boolean;
    deleterolemapping(name: any): boolean;
    CopySecret(field: any): void;
}
export declare class DuplicatesCtrl extends entitiesCtrl<Base> {
    $scope: ng.IScope;
    $location: ng.ILocationService;
    $routeParams: ng.route.IRouteParamsService;
    $interval: ng.IIntervalService;
    WebSocketClientService: WebSocketClientService;
    api: api;
    userdata: userdata;
    collections: any;
    model: Base;
    uniqeness: string;
    constructor($scope: ng.IScope, $location: ng.ILocationService, $routeParams: ng.route.IRouteParamsService, $interval: ng.IIntervalService, WebSocketClientService: WebSocketClientService, api: api, userdata: userdata);
    keys: string[];
    processdata(): Promise<void>;
    ToggleUniqeness(model: any): void;
    ShowData(model: any): Promise<void>;
    CloseModal(): Promise<void>;
    OpenEntity(model: any): void;
    MassDeleteOnlyOne(): Promise<void>;
    MassDeleteAllButOne(): Promise<void>;
    MassDeleteAll(): Promise<void>;
    DeleteOnlyOne(model: any): Promise<void>;
    DeleteAllButOne(model: any): Promise<void>;
    DeleteAll(model: any): Promise<void>;
    ModalDeleteOne(model: any): Promise<void>;
}
